Bug 108801 - Text blurred on Retina screen with low-res monitor as second screen
Summary: Text blurred on Retina screen with low-res monitor as second screen
Status: REOPENED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
5.3.3.2 release
Hardware: x86-64 (AMD64) macOS (All)
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: Multimonitor
  Show dependency treegraph
 
Reported: 2017-06-26 20:52 UTC by Joost Egelie
Modified: 2021-01-28 22:08 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments
Composite showing laptop (larger) and external (smaller) monitors. (2.24 MB, image/png)
2019-03-06 21:37 UTC, okinasevych
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Joost Egelie 2017-06-26 20:52:46 UTC
Description:
Text and icons in LibreOffice are blurry (render intended for lo-res screen) on a Mac "Retina" screen, while a low resolution monitor is attached as second screen (Apple Thunderbolt Display in my case).

Steps to Reproduce:
1. start MacBook fresh without external monitor, launch LibreOffice, enjoy crisp text and UI.
2. attach low resolution monitor (in my case Apple Thunderbolt Display), text stays clean and crisp until window resize (or any redraw event).
3. unplug monitor, text in LibreOffice appears crisp instantly.

Actual Results:  
Blurred text on a Retina screen

Expected Results:
Not blurred on the Retina screen, "normal" on the low resolution monitor.


Reproducible: Always

User Profile Reset: Yes.

Additional Info:
The issue has been on and off in the bugtracker, seems all issues were closed due to no reproducibility. No info found on second monitor combos though; I suspect a bug in the mechanism that determines what resolution is available, not accounting multiple screens and no awareness of which resolution the Writer window is currently on.

A drag test with a native Apple app (Safari) over the two screens reveals the window is shown either on one or the other screen, not floating half on both screens at the same time. This is natural behaviour, and a suggestion for the arising problem of what to do when a LibreOffice screen hovers over the two different screens.

MacBook Pro Retina 15 inch mid-2015 model, as purchased from Apple in May 2017 (15,4-inch (2880 x 1800), Intel Iris Pro 1536 MB).
Apple Thunderbolt Display connected through thunderbolt (27-inch (2560 x 1440)).
MacOS X Sierra 10.12.5


User-Agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/603.2.4 (KHTML, like Gecko) Version/10.1.1 Safari/603.2.4
Comment 1 Alex Thurgood 2017-06-27 07:27:46 UTC
@Joost :

1) how do you attach your Thunderbolt display - HDMI, Thunderbolt2, or DVI, or some other mechanism (eg. docking station) ?

2) how have you setup OSX behaviour when an external monitor is plugged in ? I am guessing that you are not synching the display between the Macbook and the TB monitor (since you mention sliding app windows from MBPro to external display ?
Comment 2 Joost Egelie 2017-06-27 11:05:01 UTC
@Alex:

1. Attached via Thunderbolt 1 cable, but not the monitor's own Thunderbolt 1 cable. This makes no difference for the functionality of the monitor and its hub features (thus Thunderbolt 1 cable from one Macbook port to one Apple Thunderbolt Display port)

2. OS X behaviour: extended desktop. I've tried to set up either screen as the main display (i.e. dragging the menubar over to one or other screen in the Display preferences panel) and I've tried launching LibreOffice from a Dock parked on either one display, both to no avail.
Comment 3 Alex Thurgood 2017-06-27 12:22:46 UTC
@Joost : thanks for the update, I have a very similar setup to you, so I can test this for myself and report back here.
Comment 4 Alex Thurgood 2017-06-27 12:39:08 UTC
I can only confirm this if I set the option under Preferences > Monitor to Thunderbolt Display.

If I leave the display as Integrated Retina Screen, I don't see the fuzzy text/icon behaviour.

Confirming.
Comment 5 QA Administrators 2018-06-28 02:48:04 UTC Comment hidden (obsolete)
Comment 6 okinasevych 2019-03-06 21:32:52 UTC
I had noticed intermittent recurrence of the Retina display bug on my 2-monitor setup. I only discovered by chance that it was the second monitor that may contribute to this issue, as described here. I can reproduce the buggy display *and* I can get the display to render in higher resolution without disconnecting the second monitor. Here are my particulars which I hope will be helpful. 

About LibreOffice:

Version: 6.1.5.2
Build ID: 90f8dcf33c87b3705e78202e3df5142b201bd805
CPU threads: 4; OS: Mac OS X 10.12.6; UI render: GL; 
Locale: en-CA (en_CA.UTF-8); Calc: group threaded

Monitors:

Laptop: MacBook Pro (2015 model) 13.3-inch (2560 x 1600)
External: Samsung SMB2230H 21.5-inch (1920 x 1080), connected via Thunderbolt/DVI

Launch with low resolution:
- LibreOffice not running.
- Finder window open on _external monitor_ with an LO Writer doc available.
- Double-click the Writer doc.
- LibreOffice launches in laptop monitor. Writer document opens in _low-res_. 

Launch with high resolution:
- LibreOffice not running.
- Finder window open on _laptop monitor_ with an LO Writer doc available.
- Double-click the Writer doc.
- LibreOffice launches in laptop monitor. Writer document opens in _high-res_.
Comment 7 okinasevych 2019-03-06 21:37:33 UTC
Created attachment 149777 [details]
Composite showing laptop (larger) and external (smaller) monitors.

This shows my two monitors (redacted) with low-res external monitor above and high-res laptop monitor below. Lower laptop monitor displays high-res in all areas except in the text/edit area of LO Writer. Finder window from which I launched LO Writer is in the upper low-res monitor.
Comment 8 Arvid 2019-12-02 17:24:31 UTC
Also happening to me. macOS 10.14.6 (18G1012), Libreoffice 6.3.3.2. Only editing area is low-res. Toolbars, etc are retina. Happens whether or not I have low-res external monitors attached. okinasevych's workaround does not work for me.
Comment 9 steve 2020-11-05 10:35:55 UTC
Can someone affected by this retest with LibreOffice 7.0.3 and see if the problem is persisting. After providing feedback please set the bug back to NEW.
Comment 10 Joost Egelie 2020-11-12 21:28:22 UTC
I've had mixed experiences. I had the bug in the previous version of LibreOffice, then I wanted to reproduce when I rebooted and the text was crystal clear on the Retina screen, switching perfectly between non-Retina and Retina monitor.
I installed the 7.0.3.1 version, and the problem didn't occur until now. It is STILL existing. By the way, the About-dialog has awful graphics.
Comment 11 Joost Egelie 2020-11-12 21:43:01 UTC
In addition, the procedure described by @okinasevych in Comment 6 is repeatable on my current setup (MacBook Pro 15" Mid-2015 + Thunderbolt Display, MacOS High Sierra).

So this may give a hint of where to look for the bug. If I launch LO from the Dock and use its StartCenter for opening documents, it always gives blurry text. Somehow it may take the resolution setting on the last screen attached in some monitor device enumerator (I'm not familiar with the underlying MacOS mechanics).

Opening LO by double-clicking a document in a Finder window results in blurry text when the Finder window was on the Thunderbolt Display, and in crisp sharp text when the Finder window was on the Retina screen.
Comment 12 Alexander Barris 2020-11-13 05:07:07 UTC
(In reply to Joost Egelie from comment #11)
> In addition, the procedure described by @okinasevych in Comment 6 is
> repeatable on my current setup (MacBook Pro 15" Mid-2015 + Thunderbolt
> Display, MacOS High Sierra).
> 
> So this may give a hint of where to look for the bug. If I launch LO from
> the Dock and use its StartCenter for opening documents, it always gives
> blurry text. Somehow it may take the resolution setting on the last screen
> attached in some monitor device enumerator (I'm not familiar with the
> underlying MacOS mechanics).
> 
> Opening LO by double-clicking a document in a Finder window results in
> blurry text when the Finder window was on the Thunderbolt Display, and in
> crisp sharp text when the Finder window was on the Retina screen.

Interesting, I tried what you said to do and found the opposite. Opening from the Thunderbolt Display (from Finder) to the Thunderbolt display resulted in clear text, whereas opening it from Finder on the Retina display for the Retina display resulted in blurry text.
Comment 13 Timur 2021-01-21 10:02:24 UTC
See Also bug just had a fix, please test with https://dev-builds.libreoffice.org/daily/master/current.html
Comment 14 Joost Egelie 2021-01-26 20:19:23 UTC
Sorry I got back so late on this. Apparently the 22/01/2021 and the 26/01/2021 build crash upon launch, so I can't check. This may be since I'm not a developer and may be missing some libs in my environment - I don't know. It says (not pasting the complete report):

Crashed Thread:        0  Dispatch queue: com.apple.main-thread

Exception Type:        EXC_CRASH (SIGABRT)
Exception Codes:       0x0000000000000000, 0x0000000000000000
Exception Note:        EXC_CORPSE_NOTIFY

Application Specific Information:
*** Terminating app due to uncaught exception 'NSInvalidArgumentException', reason: '-[VCL_NSApplication setAppearance:]: unrecognized selector sent to instance 0x608000101320'
abort() called
terminating with uncaught exception of type NSException
Comment 15 Thorsten Wagner 2021-01-27 09:53:38 UTC
Thorsten Wagner committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/f318b856ed055f1952276355f811153f6b29c93e

tdf#138122 Detect window scaling for multi display configurations on macOS

It will be available in 7.2.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 16 Joost Egelie 2021-01-27 19:15:05 UTC
Nope, still can't verify. I can't seem to be able to launch the dev builds. The "2021-01-27_05.00.47/" build also crashes on start.

Application Specific Information:
*** Terminating app due to uncaught exception 'NSInvalidArgumentException', reason: '-[VCL_NSApplication setAppearance:]: unrecognized selector sent to instance 0x604000111790'
abort() called
terminating with uncaught exception of type NSException

Do you need the full crash report?
Comment 17 Timur 2021-01-28 07:45:27 UTC
hello Joost. Your 2021-01-27_05.00.47/" was before last patch, please try today's version. 
If you have crash, try with profile reset/delete, meaning profile of master version ( if you used it before it stayed. 
Not sure if daily build requires some libs, it shouldn't. 
Would be useful to test also version before those patches (which started on 2021-01-17), please grab immediately 2021-01-16 from https://dev-builds.libreoffice.org/daily/master/MacOSX-x86_64@tb81-TDF/. 
If crashes persist, I guess you'll have to open a new report (in case it doesn't exist, please search).
Comment 18 Joost Egelie 2021-01-28 19:30:13 UTC
Yes, I managed. I think your tip on deleting the profile worked: I was able to start both the 16/01/2021 and the 28/01/2021 version. Both versions tend to start on the laptop monitor every time, which is NOT my first screen in my configuration (external Thunderbolt Display is carrying the menubar and thus designated main screen).

Major difference: the 16/01 version gave blurry text on the Retina laptop monitor. The 28/01 version did *not*. Furthermore, upon dragging to and fro monitors, the latter retained crisp visibility on both the Retina display and the Thunderbolt Display.

I think this very issue is addressed here, but in the meantime another issue occurred: remembering window position throughout sessions. I will try to find more data on that and open another ticket if it does not exist yet.
Comment 19 steve 2021-01-28 19:56:46 UTC
Setting to verified as per comment 18.
Comment 20 Xisco Faulí 2021-01-28 20:02:51 UTC
(In reply to Thorsten Wagner from comment #15)
> Thorsten Wagner committed a patch related to this issue.
> It has been pushed to "master":
> 
> https://git.libreoffice.org/core/commit/
> f318b856ed055f1952276355f811153f6b29c93e
> 
> tdf#138122 Detect window scaling for multi display configurations on macOS
> 
> It will be available in 7.2.0.
> 
> The patch should be included in the daily builds available at
> https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
> information about daily builds can be found at:
> https://wiki.documentfoundation.org/Testing_Daily_Builds
> 
> Affected users are encouraged to test the fix and report feedback.

Unfortunately, the commit was reverted in https://git.libreoffice.org/core/+/b3737c638671ab39c5e6aaeaf5426d102392cc0a%5E%21. Reopening
Comment 21 Timur 2021-01-28 22:08:54 UTC
Given are 2 reasons, Unit test fail (for what?)  and crash. 
Xisco, can you please test yourself, can it be that crash is for profile.